/*

 methods_1
 questo sorgente e' parte integrante 
 del Progetto xSudoky.
 Scritto da Max Cavallo 20/Luglio/2007
 ixamit@gmail.com

*/

#include "sudoky.h"
#include <libintl.h>
#include <locale.h>

int label_Tipo;

int CheckAll ()
{
	int y,x,b,p,bit,test;
	for (y=0;y<SUD_TAB;y++)
	{
		test=0x0;
		for (x=0;x<SUD_TAB;x++)
		{
			if (IsOnly1Candi (SUD_BUF[y][x]))
			{
				bit=SUD_BUF[y][x];
				UnsetFlagCandidato (&bit, CANDI_MSK);
				UnsetFlagCandidato (&bit, FIXED_MSK);

				if (bit & test)
				{
					sprintf (BUFF,
						gettext("Inconsistency on R%d with R%dC%d\nGo back and fix!"),
						y+1,y+1,x+1);

					Alert (BUFF,
						gettext("Ok"),NULL);

					test=-1;

					return (0);
				}
				else
				{
					test|=bit;
				}
			}
		}
	}

	for (x=0;x<SUD_TAB;x++)
	{
		test=0x0;
		for (y=0;y<SUD_TAB;y++)
		{
			if (IsOnly1Candi (SUD_BUF[y][x]))
			{
				bit=SUD_BUF[y][x];
				UnsetFlagCandidato (&bit, CANDI_MSK);
				UnsetFlagCandidato (&bit, FIXED_MSK);
				if (bit & test)
				{
					sprintf (BUFF,
						gettext("Inconsistency on C%d with R%dC%d\nGo back and fix!"),
						x+1,y+1,x+1);

					Alert (BUFF,
						gettext("Ok"),NULL);

					test=-1;

					return (0);
				}
				else
				{
					test|=bit;
				}
			}
		}
	}

	for (b=0;b<SUD_TAB;b++)
	{
		test=0x0;
		for (p=0;p<SUD_TAB;p++)
		{
			CoordinateBlocco2yx (b,p,&y,&x);
			if (IsOnly1Candi (SUD_BUF[y][x]))
			{
				bit=SUD_BUF[y][x];
				UnsetFlagCandidato (&bit, CANDI_MSK);
				UnsetFlagCandidato (&bit, FIXED_MSK);

				if (bit & test)
				{
					sprintf (BUFF,
						gettext("Inconsistency on B%d with R%dC%d\nGo back and fix!"),
						b+1,y+1,x+1);

					Alert (BUFF,
						gettext("Ok"),NULL);

					test=-1;

					return (0);
				}
				else
				{
					test|=bit;
				}
			}
		}
	}

	return (0);
		
}

//====================================================
//
//-------------------SINGLE CANDIDATE----------------
//
//====================================================
int UniqueCandidate ()
{
	int y,x;
	int candidato;
	label_Tipo=0;

	for (y=0;y<SUD_TAB;y++)
	{
		for (x=0;x<SUD_TAB;x++)
		{
			if (IsOnly1Candi (SUD_BUF[y][x]) && (IsCandi (y,x)))
			{
				if (label_Tipo++==0)
				{
					AddItemListCmd (ViewComment, LABEL,
					gettext("UNIQUE CANDIDATE"),NULL);
				}
				candidato=atoi(GetCandidati(y,x));

				InsertNumeroGUI(y,x,candidato,0);

				sprintf (BUFF,
					gettext("  Set [%d] in R%dC%d"),
					candidato,y+1,x+1);

				AddItemListCmd (ViewComment, LIST_BOX, BUFF,SudoListBoxCallBack);

			}
		}
	}
	label_Tipo=0;
	return (0);		

}
int SingleCandidateRow ()
{
	//
	int y,x;
	int candidato,count;
	int sav=0;
	label_Tipo=0;

	for (y=0;y<SUD_TAB;y++)
	{
		for (candidato=0;candidato<=SUD_TAB;candidato++)
		{
			count=0;
			for (x=0;x<SUD_TAB;x++)
			{
		
				if (
					(IsCandi(y,x)) &&
					CandiExist (SUD_BUF[y][x],candidato+1)
				    )
				{
					sav=x;
					count++;
				}
				if (count>1) break;
			}
			if (count==1)
			{

				if (label_Tipo++==0)
				{
					AddItemListCmd (ViewComment, LABEL,
					gettext("SINGLE CANDIDATE in ROW"),NULL);
				}

				InsertNumeroGUI(y,sav,candidato+1,0);

				sprintf (BUFF,
					gettext("  Set [%d] in R%dC%d"),
					candidato+1,y+1,sav+1);

				AddItemListCmd (ViewComment, LIST_BOX, BUFF,SudoListBoxCallBack);
			}
		}
	}
	label_Tipo=0;
	return (0);		
}

int SingleCandidateColumn ()
{
	//
	int y,x;
	int candidato,count;
	int sav=0;
	label_Tipo=0;

	for (x=0;x<SUD_TAB;x++)
	{
		for (candidato=0;candidato<=SUD_TAB;candidato++)
		{
			count=0;
			for (y=0;y<SUD_TAB;y++)
			{
		
				if (
					(IsCandi (y,x)) &&
					CandiExist (SUD_BUF[y][x],candidato+1)
				    )
				{
					sav=y;
					count++;
				}
				if (count>1) break;
			}
			if (count==1)
			{
				if (label_Tipo++==0)
				{
					AddItemListCmd (ViewComment, LABEL,
					gettext("SINGLE CANDIDATE in COLUMN"),NULL);
				}

				InsertNumeroGUI(sav,x,candidato+1,0);

				sprintf (BUFF,
					gettext("  Set [%d] in R%dC%d"),
					candidato+1,sav+1,x+1);

				AddItemListCmd (ViewComment, LIST_BOX, BUFF,SudoListBoxCallBack);
			}
		}
	}
	label_Tipo=0;
	return (0);		
}

int SingleCandidateBox ()
{
	//
	int y,x,b,p;
	int candidato,count;
	int sav=0;
	label_Tipo=0;

	for (b=0;b<SUD_TAB;b++)
	{
		for (candidato=0;candidato<=SUD_TAB;candidato++)
		{
			count=0;
			for (p=0;p<SUD_TAB;p++)
			{
				CoordinateBlocco2yx (b,p,&y,&x);
				if (
					(IsCandi (y,x)) &&
					CandiExist (SUD_BUF[y][x],candidato+1)
				    )
				{
					sav=p;
					count++;
				}
				if (count>1) break;
			}
			if (count==1)
			{
				if (label_Tipo++==0)
				{

					AddItemListCmd (ViewComment, LABEL,
					gettext("SINGLE CANDIDATE in BOX"),NULL);
				}

				CoordinateBlocco2yx (b,sav,&y,&x);
				InsertNumeroGUI(y,x,candidato+1,0);

				sprintf (BUFF,
					gettext("  Set [%d] in R%dC%d"),candidato+1,y+1,x+1);

				AddItemListCmd (ViewComment, LIST_BOX, BUFF,SudoListBoxCallBack);
			}
		}
	}
	label_Tipo=0;
	return (0);		
}

int SingleCandidate ()
{
	Clear_Comments ();

	UniqueCandidate ();
	SingleCandidateRow ();
	SingleCandidateColumn ();
	SingleCandidateBox ();

	SudoFinish(SOLVE); //ex 1 fisso

	return (0);
}
//====================================================
//
//---------------------INTERSEZIONI-------------------
//
//====================================================
int IntersezioneCancella (int Tipo,int Riga_o_Colonna,int Candidato, int Blocco, int numref,int ref[])
{
	//
	// Richiamata da Metodo Intersezione Righe/Colonne
	//
	// Elimina i candidati sulla Riga o Colonna o Blocco
	// (definito da Tipo)
	//
	char buffref[20],*pbr;
	int y,x,b,p;
	int count=0;
	
	pbr=buffref;
	for (x=0;x<numref;x++,pbr+=6)
	{
		if (Tipo==1)	sprintf (pbr,"R%dC%d, ",Riga_o_Colonna+1,ref[x]);
		if (Tipo==2)	sprintf (pbr,"R%dC%d, ",ref[x],Riga_o_Colonna+1);
		if (Tipo==3)	sprintf (pbr,"R%dC%d, ",Riga_o_Colonna+1,ref[x]);
		if (Tipo==4)	sprintf (pbr,"R%dC%d, ",ref[x],Riga_o_Colonna+1);

	}
	if (numref){	*(pbr-2)='\0'; pbr=buffref;}
	
	if (Tipo==1)
	{
		// BloccoRiga
		y=Riga_o_Colonna;
		for (x=0;x<SUD_TAB;x++)
		{
			Coordinateyx2Blocco (y,x,&b,&p);
			if (
				CandiExist (SUD_BUF[y][x],Candidato)
				&& Blocco!=b
			    )
			{

				RemoveCandidatoGUI(y,x,Candidato,0);
				if (label_Tipo++==0)
				{
					AddItemListCmd (ViewComment, LABEL,
					gettext("INTERSECTION REMOVAL BOX-ROW") , NULL);
				}
				if (count==0)
				{

					sprintf (BUFF,
					gettext("  Found [%d] in Box %d on %s"),
					Candidato,Blocco+1,buffref);

					AddItemListCmd (ViewComment, LIST_BOX, BUFF,NULL);
				}

				sprintf (BUFF,
					gettext("    Unset [%d] in R%dC%d"),
					Candidato,y+1,x+1);

				AddItemListCmd (ViewComment, LIST_BOX, BUFF,NULL);
				
				count++;
			}
				
		}
		
	}
	if (Tipo==2)
	{
		// BloccoColonna
		x=Riga_o_Colonna;
		for (y=0;y<SUD_TAB;y++)
		{
			Coordinateyx2Blocco (y,x,&b,&p);
			if (
				CandiExist (SUD_BUF[y][x],Candidato)
				 && Blocco!=b
			    )
			{

				RemoveCandidatoGUI(y,x,Candidato,0);

				if (label_Tipo++==0)
				{
					AddItemListCmd (ViewComment, LABEL,
					gettext("INTERSECTION REMOVAL BOX-COLUMN") , NULL);
				}
				if (count==0)
				{
					sprintf (BUFF,
					gettext("  Found [%d] in Box %d on %s"),
					Candidato,Blocco+1,buffref);

					AddItemListCmd (ViewComment, LIST_BOX, BUFF,NULL);
				}

				sprintf (BUFF,gettext("    Unset [%d] in R%dC%d"),
				Candidato,y+1,x+1);

				AddItemListCmd (ViewComment, LIST_BOX, BUFF,NULL);
				
				count++;
			}
				
		}
		
	}
	if (Tipo==3)
	{
		// RigaBlocco
		for (p=0;p<SUD_TAB;p++)
		{
			CoordinateBlocco2yx (Blocco,p,&y,&x);
			if (
				CandiExist (SUD_BUF[y][x],Candidato)
				&& Riga_o_Colonna!=y
			    )
			{
				RemoveCandidatoGUI(y,x,Candidato,0);

				if (label_Tipo++==0)
				{
					AddItemListCmd (ViewComment, LABEL,
					gettext("INTERSECTION REMOVAL ROW-BOX") , NULL);
				}

				if (count==0)
				{
					sprintf (BUFF,
					gettext("  Found [%d] in Box %d on %s"),
					Candidato,Blocco+1,buffref);

					AddItemListCmd (ViewComment, LIST_BOX, BUFF,NULL);
				}

				sprintf (BUFF,
					gettext("    Unset [%d] in R%dC%d"),
					Candidato,y+1,x+1);

				AddItemListCmd (ViewComment, LIST_BOX, BUFF,NULL);
				
				count++;
			}

		}
	}
	if (Tipo==4)
	{
		// ColonnaBlocco
		for (p=0;p<SUD_TAB;p++)
		{
			CoordinateBlocco2yx (Blocco,p,&y,&x);
			if (
				CandiExist (SUD_BUF[y][x],Candidato) &&
				Riga_o_Colonna!=x
			    )
			{
				RemoveCandidatoGUI(y,x,Candidato,0);
				if (label_Tipo++==0)
				{
					AddItemListCmd (ViewComment, LABEL,
					gettext("INTERSECTION REMOVAL COLUMN-BOX") , NULL);
				}

				if (count==0)
				{
					sprintf (BUFF,
					gettext("  Found [%d] in Box %d on %s"),
					Candidato,Blocco+1,buffref);

					AddItemListCmd (ViewComment, LIST_BOX, BUFF,NULL);
				}

				sprintf (BUFF,
					gettext("    Unset [%d] in R%dC%d"),
					Candidato,y+1,x+1);

				AddItemListCmd (ViewComment, LIST_BOX, BUFF,NULL);
				
				count++;
			}

		}
	}

	return (0);
}

int IntersBoxRow ()
{
	//
	// Intersezione Blocco su Riga
	//
	// Questo metodo ricerca i candidati del blocco 
	// presenti solo sulla stessa riga o colonna 
	// della medesima.
	// Possono quindi essere eliminati gli stessi 
	// candidati presenti sulla stessa riga ma in 
	// blocchi diversi.
	// Esempio:
	// {38} {1} {278}
	// {978}{46}{258}
	// {67} {5} {289}
	// Questo e' un blocco che ha il candidato {2}
	// presente solo sulla 3a colonna.Si possono quindi 
	// eliminare tutti i candidati {2} presenti sulla
	// stessa colonna ma in altri blocchi 
	//
	int b,p,x,y,r[3];
	int sav,found;
	int candidato;
	label_Tipo=0;

	for (b=0;b<SUD_TAB;b++)
	{
		for (candidato=1;candidato<=SUD_TAB;candidato++)
		{
			sav=0;found=0;
			for (p=0;p<SUD_TAB;p++)
			{	
				CoordinateBlocco2yx (b,p,&y,&x);
				if (
					CandiExist (SUD_BUF[y][x],candidato) &&
					(IsCandi (y,x))
				    )
				{
					if (found && sav!=y) 
					{
						found=0;
						break; 
					}
					sav=y;
					r[found++]=x+1;
				}
			}
			if (found)
			{
				IntersezioneCancella (1,sav,candidato,b,found,r);
			}
		}
	}
	label_Tipo=0;

	return (0);

}

int IntersBoxColumn ()
{
	//
	// Intersezione Blocco su Colonna 
	//
	// Questo metodo ricerca i candidati del blocco 
	// presenti solo sulla stessa riga o colonna 
	// della medesima.
	// Possono quindi essere eliminati gli stessi 
	// candidati presenti sulla stessa riga ma in 
	// blocchi diversi.
	// Esempio:
	// {38} {1} {278}
	// {978}{46}{258}
	// {67} {5} {289}
	// Questo e' un blocco che ha il candidato {2}
	// presente solo sulla 3a colonna.Si possono quindi 
	// eliminare tutti i candidati {2} presenti sulla
	// stessa colonna ma in altri blocchi 
	//
	int b,p,x,y,r[3];
	int sav,found;
	int candidato;
	label_Tipo=0;
	
	for (b=0;b<SUD_TAB;b++)
	{
		for (candidato=1;candidato<=SUD_TAB;candidato++)
		{
			sav=0;found=0;
			for (p=0;p<SUD_TAB;p++)
			{	
				CoordinateBlocco2yx (b,p,&y,&x);
				if (
					CandiExist (SUD_BUF[y][x],candidato) &&
					(IsCandi (y,x))
				    )
				{
					if (found && sav!=x) 
					{
						found=0;
						break; 
					}
					sav=x;
					r[found++]=y+1;
				}
			}
			if (found)
			{
				IntersezioneCancella (2,sav,candidato,b,found,r);
			}
		}
	}
	label_Tipo=0;
	return (0);

}

int IntersRowBox ()
{
	//
	// Intersezione Riga su Blocco
	//
	int x,y,b,p,r[3];
	int sav,found;
	int candidato;
	label_Tipo=0;

	for (y=0;y<SUD_TAB;y++)
	{
		for (candidato=1;candidato<=SUD_TAB;candidato++)
		{
			sav=0;found=0;
			for (x=0;x<SUD_TAB;x++)
			{
				if (
					CandiExist (SUD_BUF[y][x],candidato) &&
					(IsCandi (y,x))
				    )
				{
					Coordinateyx2Blocco (y,x,&b,&p);
					if (found && sav!=b) 
					{
						found=0;
						break; 
					}
					sav=b;
					r[found++]=x+1;
				}

			}
			if (found)
			{
				IntersezioneCancella (3,y,candidato,b,found,r);
			}
		}
	}
	label_Tipo=0;

	return (0);

}

int IntersColumnBox ()
{
	//
	// Intersezione Colonna su Blocco
	//
	int x,y,b,p,r[3];
	int sav,found;
	int candidato;
	label_Tipo=0;

	for (x=0;x<SUD_TAB;x++)
	{
		for (candidato=1;candidato<=SUD_TAB;candidato++)
		{
			sav=0;found=0;
			for (y=0;y<SUD_TAB;y++)
			{
				if (
					CandiExist (SUD_BUF[y][x],candidato) &&
					(IsCandi (y,x))
				    )
				{
					Coordinateyx2Blocco (y,x,&b,&p);
					if (found && sav!=b) 
					{
						found=0;
						break; 
					}
					sav=b;
					r[found++]=y+1;
				}

			}
			if (found)
			{
				IntersezioneCancella (4,x,candidato,b,found,r);
			}
		}
	}
	label_Tipo=0;
	return (0);

}
int IntersectionRemoval ()
{
	Clear_Comments ();

	IntersBoxRow ();
	IntersBoxColumn ();
	IntersRowBox ();
	IntersColumnBox ();

	SudoFinish(SOLVE); // ex 1 fisso

	return (0);

}
